<template>
  <v-card color="basil" class="responsive-card">
    <v-card-title class="text-center justify-center py-6">
      <h1 class="font-weight-bold text-h2 text-basil">Salary</h1>
    </v-card-title>
    <v-tabs v-model="tab" bg-color="transparent" color="basil" grow>
      <v-tab v-for="item in items" :key="item" :value="item">
        {{ item }}
      </v-tab>
    </v-tabs>
    <v-window v-model="tab">
      <v-window-item v-for="item in items" :key="item" :value="item">
        <v-card color="basil" flat>
          <v-card-text v-if="item === 'Payment'">
            <!-- ปุ่มเพื่อเปิดไดอะล็อก -->
            <v-dialog v-model="dialog" persistent width="1024">
              <template v-slot:activator="{ props }">
                <v-btn color="green" v-bind="props">
                  <v-icon>mdi mdi-plus</v-icon> Add New Salary
                </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <span class="text-h5">Add New Salary</span>
                </v-card-title>
                <v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="save">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedPayment.date"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Date"
                            type="date"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedPayment.userId"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="ID"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedPayment.workingHours"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="WorkingHours"
                            type="number"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedPayment.workRate"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="WorkRate"
                            type="number"
                          ></v-text-field>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form>
                  <small>* indicates required field</small>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                  <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>

            <!-- ตารางเงินเดือน -->
            <v-data-table :headers="paymentTableHeader" :items="paymentTableData">
              <template v-slot:item.action="{ item }">
                <v-btn @click="handlePay(item)" color="primary">Pay</v-btn>
              </template>
              <!-- เพิ่มส่วนแสดง Status -->
              <template v-slot:item.status="{ item }">
                <span v-if="!item.status">Not Paid</span>
              </template>
            </v-data-table>
          </v-card-text>
          <!-- เพิ่มส่วนประวัติ -->
          <v-card-text v-if="item === 'History'">
            <v-data-table :headers="historyTableHeader" :items="historyTableData">
              <!-- ส่วนการแสดงข้อมูลในตารางประวัติ -->
            </v-data-table>
          </v-card-text>
        </v-card>
      </v-window-item>
    </v-window>
  </v-card>
</template>

<script setup lang="ts">
import { ref } from 'vue'

const tab = ref('Payment')
const items = ['Payment', 'History']
const dialog = ref(false)
const loading = ref(false)
const form = ref({})
const editedPayment = ref({
  date: '',
  userId: '',
  workingHours: '',
  workRate: ''
})

const paymentTableHeader = [
  { text: 'Date', value: 'date' },
  { text: 'ID', value: 'userId' },
  { text: 'Working Hours', value: 'workingHours' },
  { text: 'Work Rate', value: 'workRate' },
  { title: 'Action', key: 'action', sortable: false },
  { title: 'Status', key: 'status' } // เพิ่ม column สำหรับแสดง Status
]

const paymentTableData = ref([
  { date: '2024-02-02', userId: '1', workingHours: 8, workRate: 10, action: 'Pay', status: '' }
])

const historyTableHeader = [
  { text: 'Date', value: 'date' },
  { text: 'ID', value: 'userId' },
  { text: 'Working Hours', value: 'workingHours' },
  { text: 'Work Rate', value: 'workRate' },
  { title: 'Status', key: 'status' }
]

const historyTableData = ref([]) // ประกาศ historyTableData เป็น ref และกำหนดค่าเริ่มต้นเป็น array เปล่า

function handlePay(item) {
  console.log('Payment action for item:', item)
  const paymentEntry = paymentTableData.value.find((entry) => entry === item) // เปลี่ยนจาก entry.id เป็น entry เพื่อให้เปรียบเทียบโดยตรง
  const index = paymentTableData.value.indexOf(paymentEntry)
  paymentTableData.value.splice(index, 1)
  paymentEntry.status = 'Paid' // ตั้งค่าสถานะเป็น 'Paid'

  // เพิ่มข้อมูลที่จ่ายเข้าสู่ historyTableData
  historyTableData.value.push(paymentEntry) // ใช้ .value เพื่อเข้าถึงค่าของ ref
}

function closeDialog() {
  dialog.value = false
}

function save() {
  const newData = {
    date: editedPayment.value.date,
    userId: editedPayment.value.userId,
    workingHours: editedPayment.value.workingHours,
    workRate: editedPayment.value.workRate,
    status: '' // เพิ่มสถานะเริ่มต้นเป็นค่าว่าง
  }

  paymentTableData.value.push(newData)

  editedPayment.value.date = ''
  editedPayment.value.userId = ''
  editedPayment.value.workingHours = ''
  editedPayment.value.workRate = ''

  dialog.value = false
}
</script>
